// Code generated by MockGen. DO NOT EDIT.
// Source: async/AsyncInterface.go

// Package mock_async is a generated GoMock package.
package mock_async

import (
	context "context"
	reflect "reflect"

	message "github.com/ThreeDotsLabs/watermill/message"
	gomock "github.com/golang/mock/gomock"
	async "gitlab.com/nikolai.straessle/echomiddleware/v7/async"
)

// MockAsync is a mock of Async interface.
type MockAsync struct {
	ctrl     *gomock.Controller
	recorder *MockAsyncMockRecorder
}

// MockAsyncMockRecorder is the mock recorder for MockAsync.
type MockAsyncMockRecorder struct {
	mock *MockAsync
}

// NewMockAsync creates a new mock instance.
func NewMockAsync(ctrl *gomock.Controller) *MockAsync {
	mock := &MockAsync{ctrl: ctrl}
	mock.recorder = &MockAsyncMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockAsync) EXPECT() *MockAsyncMockRecorder {
	return m.recorder
}

// Init mocks base method.
func (m *MockAsync) Init(driverName, dsn, appName string) (async.Async, error) {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Init", driverName, dsn, appName)
	ret0, _ := ret[0].(async.Async)
	ret1, _ := ret[1].(error)
	return ret0, ret1
}

// Init indicates an expected call of Init.
func (mr *MockAsyncMockRecorder) Init(driverName, dsn, appName interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Init", reflect.TypeOf((*MockAsync)(nil).Init), driverName, dsn, appName)
}

// Publish mocks base method.
func (m *MockAsync) Publish(topicName string, payloadInterface interface{}, tenantID uint, messageType, action string, metadata map[string]string) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Publish", topicName, payloadInterface, tenantID, messageType, action, metadata)
	ret0, _ := ret[0].(error)
	return ret0
}

// Publish indicates an expected call of Publish.
func (mr *MockAsyncMockRecorder) Publish(topicName, payloadInterface, tenantID, messageType, action, metadata interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Publish", reflect.TypeOf((*MockAsync)(nil).Publish), topicName, payloadInterface, tenantID, messageType, action, metadata)
}

// Subscribe mocks base method.
func (m *MockAsync) Subscribe(topicName string, processMsgFunction func(*message.Message) error, ctx context.Context) error {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "Subscribe", topicName, processMsgFunction, ctx)
	ret0, _ := ret[0].(error)
	return ret0
}

// Subscribe indicates an expected call of Subscribe.
func (mr *MockAsyncMockRecorder) Subscribe(topicName, processMsgFunction, ctx interface{}) *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "Subscribe", reflect.TypeOf((*MockAsync)(nil).Subscribe), topicName, processMsgFunction, ctx)
}
